#ifndef _GLERROR_H
#define _GLERROR_H

#include <stdio.h>

#ifdef _DEBUG
#define CheckGLError( locString ) \
    { \
        GLenum errCode; \
        if ((errCode = glGetError()) != GL_NO_ERROR) \
        { \
            switch( errCode ) \
            { \
                case GL_INVALID_ENUM: \
                    fprintf( stderr, "%s --- OpenGL Error: GL_INVALID_ENUM -- GLenum argument out of range\n" ); \
                    break; \
                case GL_INVALID_VALUE: \
                    fprintf( stderr, "%s --- OpenGL Error: GL_INVALID_VALUE -- Numeric argument out of range\n" ); \
                    break; \
                case GL_INVALID_OPERATION: \
                    fprintf( stderr, "%s --- OpenGL Error: GL_INVALID_OPERATION -- Operation illegal in current state\n" ); \
                    break; \
                case GL_STACK_OVERFLOW: \
                    fprintf( stderr, "%s --- OpenGL Error: GL_STACK_OVERFLOW -- Command would cause stack overflow\n" ); \
                    break; \
                case GL_STACK_UNDERFLOW: \
                    fprintf( stderr, "%s --- OpenGL Error: GL_STACK_UNDERFLOW -- Command would cause stack underflow\n" ); \
                    break; \
                case GL_OUT_OF_MEMORY: \
                    fprintf( stderr, "%s --- OpenGL Error: GL_OUT_OF_MEMORY -- Not enough memory left to execute command\n" ); \
                    break; \
            } \
        } \
    }
#else
#define CheckGLError( locString )
#endif

#endif
