
#ifndef _NVDDS_H_INCLUDED
#define _NVDDS_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#include <GLES/gl.h>

#define NVDDS_MAX_MIPMAPS       (16)
#define NVDDS_NUM_CUBEMAP_FACES (6)

typedef struct {
    int width, height, depth;
    int components;
    int compressed, cubemap, volume;
    int numMipmaps;
    GLenum format;
    void *data[NVDDS_MAX_MIPMAPS * NVDDS_NUM_CUBEMAP_FACES];
    int   size[NVDDS_MAX_MIPMAPS * NVDDS_NUM_CUBEMAP_FACES];
} NVDDSImage;

NVDDSImage *NVDDSLoad(char *filename);
void        NVDDSFree(NVDDSImage *image);

#ifdef __cplusplus
}
#endif

#endif // _NVDDS_H_INCLUDED
